//----------------------------------------------------------------------------
//
// C++ Objects for Allegro's gui
//
// Douglas Eleveld (D.J.Eleveld@anest.azg.nl)
//
//----------------------------------------------------------------------------

/*

TESTING OF THE INIfile CLASS

*/

#include <iostream.h>
#include <stdlib.h>
#include "inifile.h"

/////////////////////////////////
int main()
{
  INIfile ini;

  if(ini.open("test.ini")==false)
     {
     cerr << "INIfile does not exist, creating...\n";
     if(ini.create("test.ini")==false) return 1;
     }
  else
     {
     cerr << "Found INIfile 'test.ini'\n";
     }

  // Read some parameters
  int driver = ini("Screen","Driver",1);
  int xres   = ini("Screen","Xres",1024);
  int yres   = ini("Screen","Yres",768);
  bool flag  = ini("Screen","Flag",true);
  double d   = ini("Screen","Double",0.10101);

  cout<<"Driver: "<<driver<<endl;
  cout<<"Xres:   "<<xres<<endl;
  cout<<"Yres:   "<<yres<<endl;
  cout<<"Flag:   "<<flag<<endl;
  cout<<"Double: "<<d<<endl;

  // Write some parameters
  ini.set("Screen","Xres",640);
  ini.set("Screen","Yres",400);
  ini.set("Screen","Flag",true);
  ini.set("Screen","Double",3.14);

  // Show all existing parameters...
  cout<<"\nExisting parameters:\n";

  char *sec,*par;
  int sn=0;

  while((sec=ini.get_section_name(sn)) != NULL)
  {
    cout<<"SECTION: "<<sec<<endl;
    int pn=0;
    while((par=ini.get_name(sn,pn)) != NULL)
    {
      cout<<"  "<<par<<endl;
      pn++;
    };
    sn++;
  };


  // Close file.
  // This will also be done in the destructor
  ini.close();

  return 0;
}
